<template>
  <v-container>
    <v-overlay :value="loading">
      <v-progress-circular indeterminate size="64"></v-progress-circular>
    </v-overlay>
    <!-- Alert error -->
    <v-row loading v-if="error">
      <v-col cols="12">
        <v-alert border="left" :color="alert.type" dark>
          {{ alert.msg }}
        </v-alert>
      </v-col>
    </v-row>

    <!-- Alert success -->
    <v-row loading v-if="sending">
      <v-col cols="12">
        <div class="d-flex flex-column">
          <span class="text-h4 font-weight-bold white--text pb-2"
            >Gracias!</span
          >
          <span class="text-subtitle white--text mb-10">
            Siga las instrucciones del mail enviado para instalar nuestra app.
          </span>
          <v-btn link rounded small width="150px" to="/">Home</v-btn>
        </div>
      </v-col>
    </v-row>

    <!-- Form -->
    <v-row v-else>
      <v-col cols="12" class="mb-15">
        <v-form ref="form" lazy-validation>
          <v-row>
            <v-col cols="12" md="6">
              <span class="white--text">Nombre</span>
              <v-text-field
                v-model="prospect.name"
                :rules="fieldRules"
                dense
                solo
                rounded
                placeholder="Ingrese el nombre"
              >
              </v-text-field>
            </v-col>
            <v-col cols="12" md="6">
              <span class="white--text">Apellido</span>
              <v-text-field
                v-model="prospect.lastname"
                :rules="fieldRules"
                dense
                solo
                rounded
                placeholder="Ingrese el apelido"
              >
              </v-text-field>
            </v-col>
            <v-col cols="12" md="12">
              <span class="white--text">Mail</span>
              <v-text-field
                v-model="prospect.email"
                :rules="emailRules"
                dense
                solo
                rounded
                placeholder="Ingrese el mail"
              >
              </v-text-field>
            </v-col>
          </v-row>
          <v-row>
            <v-col class="text-end">
              <v-btn
                color="white"
                width="150"
                :block="$vuetify.breakpoint.smAndDown"
                rounded
                @click="sendProspect()"
              >
                Enviar
              </v-btn>
            </v-col>
          </v-row>
        </v-form>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import apiService from "@/services/apiService";
export default {
  name: "Prospect",
  data: () => ({
    loading: false,
    sending: false,
    error: false,
    alert: {},
    fieldRules: [(v) => !!v || "Este campo es requerido"],
    emailRules: [
      (v) => !!v || "Este campo es requerido",
      (v) => /.+@.+\..+/.test(v) || "Email invalido",
    ],
    prospect: {
      name: null,
      lastname: null,
      email: null,
    },
  }),

  methods: {
    async sendProspect() {
      try {
        if (this.$refs.form.validate()) {
          this.loading = true;
          await apiService.createProspect(this.prospect);
          this.error = false;
          this.sending = true;
          this.restore();
        }
      } catch (e) {
        this.alert = this.getAlert(e.response.status, e.response.data);
        this.error = true;
        this.restore();
      }
    },

    restore() {
      this.loading = false;
      this.$refs.form.reset();
    },
  },
};
</script>

<style></style>
